﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Activation;
using System.Text;
using System.Threading.Tasks;
using System.Web.Script.Serialization;

namespace DynamicActivitySample.Service
{
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class DynamicActivityService : IDynamicActivityService
    {
        public string About()
        {
            return "Sample Dynamic Activity Service";
        }

        public void SampleDynamicRequest(DynamicRequest request)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            Dictionary<string, object> parameters = (Dictionary<string, object>)serializer.DeserializeObject(request.Parameters);
            // hardcoded actions just used as a sample 
            switch (request.Action)
            {
                case "One":
                    string paramOne = parameters.GetStringValue("First");
                    // do specific action 
                    break;
                case "Two":
                    string one = parameters.GetStringValue("One");
                    string two = parameters.GetStringValue("Two");
                    // do specific action 
                    break;
                default:
                    // you can also loop through all parameters instead of using them by name as in these samples
                    string test1 = parameters.GetStringValue("Test1");
                    string test2 = parameters.GetStringValue("Test2");
                    string test3 = parameters.GetStringValue("Test3");
                    string test4 = parameters.GetStringValue("Test4");
                    string test5 = parameters.GetStringValue("Test5");
                    // do specific action 
                    break;
            }
        }

        public string SampleDynamicResponse(string action)
        {
            // hardcodes actions and responses here just used as a sample
            Dictionary<string, string> dynamicValues = new Dictionary<string, string>();
            switch (action)
            {
                case "GoApe":
                    dynamicValues.Add("AttributeOne", "Orangutan");
                    dynamicValues.Add("AttributeTwo", "Gorilla");
                    dynamicValues.Add("AttributeThree", "Chimpanzee");
                    dynamicValues.Add("AttributeFour", "Bonobo");
                    break;
                case "OldDutchSchool":
                    dynamicValues.Add("First", "Aap");
                    dynamicValues.Add("Second", "Noot");
                    dynamicValues.Add("Third", "Mies");
                    break;
                default:
                    dynamicValues.Add("One", "Yes");
                    dynamicValues.Add("Two", "No");
                    break;
            }
            // part of the dynamic interface trick
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            return serializer.Serialize(dynamicValues);
        }
    }

    internal static class ExtenstionHolderSomething // not really best practice to have multiple classes in one file
    {
        internal static string GetStringValue(this Dictionary<string, object> dict, string key)
        {
            if (!dict.ContainsKey(key)) return string.Empty;
            return (string)dict[key];
        }
    }
}
